#include <bits/stdc++.h>

using namespace std;

int a[1000010], A[1000010];

int main()
{
	int n;
	
	cin >> n;
	
	for(int i = n - 1; i >= 0; i--) 
	{
		cin >> a[i];
		
		A[i] = a[i];
	}
	sort(A, A + n);
	
	bool b = false;
	
	int x, y;
	
	for(int i = n - 1; i > 0; i--)
		if(A[i] != a[i])
		{
			b = true;
			x = a[i];
			a[i] = A[i]; 
			y = a[i];
			break;
		}
	
	if(b)
	{
		for(int i = 0; i < n; i++)
			if(a[i] == y)
			{
				a[i] = x;
				break;
			}
	}
	else
	{
		int k = a[1];
		a[1] = a[0];
		a[0] = k;
	}
	
	
	for(int i = n - 1; i >= 0; i--) cout << a[i] << " ";
	return 0;
}